<template>
  <div class="component-container">
    <lenna-modal ref="lennaModal"></lenna-modal>
    <lenna-loading v-show="isLoading"></lenna-loading>

    <h3 class="text-primary">Bot Integration</h3>
    <hr>

    <form @submit.prevent="submitForm">
      <div class="form-group">
        <span class="text-muted">Select a Bot that you want to connect.</span>
      </div>

      <div class="form-group row">
        <div class="col-sm-10">
          <select name="bot" class="form-control" v-model="form.botId">
            <!-- <option value="0">Select Bot</option> -->
            <option :value="bot.bot.id" v-for="(bot,key) in botList" :key="key">{{bot.bot.name}}</option>
          </select>
        </div>
      </div>

      <div class="form-group row">
        <input type="hidden" v-model="form.status">
        <div class="col-sm-6">
          <button
            type="button"
            class="btn btn-rounded btn-block"
            :class="(!form.status) ? 'btn-secondary': 'btn-danger'"
            :disabled="!form.status"
            @click="disconnectChannel"
          >Disconnect</button>
        </div>
        <div class="col-sm-6">
          <button
            type="submit"
            class="btn btn-rounded btn-block btn-primary"
          >{{(form.status) ? 'Update': 'Connect'}}</button>
        </div>
      </div>
    </form>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";

export default {
  data() {
    return {
      form: {
        botId: 0,
        status: false,
        channelName: "bot"
      },
      botList: [],
      user: this.$store.getters.localStorage.user
    };
  },
  computed: {
    isLoading() {
      return this.$store.getters.isLoading;
    }
  },
  methods: {
    // hideModal () {
    //   this.$refs.modalInfo.hide()
    // },
    async disconnectChannel() {
      try {
        let data = {
          channelName: this.form.channelName,
          status: false
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.$refs.lennaModal.show("info", "Success", response.message);

        this.form.status = false;
        EventBus.$emit("toggleStatusMain", "bot");
      } catch (error) {
        this.form.status = !this.form.status;
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          let formData = { ...this.form, status: true };
          let response = await this.$axios.post(
            `api/${this.$store.getters.appId.hashed}/integrate`,
            formData
          );
          this.form.status = true;

          this.$refs.lennaModal.show("info", "Success", response.data.message);

          EventBus.$emit("toggleStatusMain", "bot");
        } catch (error) {
          this.$refs.lennaModal.show("alert", "Error", "Something wrong!");
        }
      } else {
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          "You must correct your form first"
        );
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      let channelData = response.data.find(function(item) {
        return item.name == "bot";
      }).integration;

      if (channelData != null) {
        this.form.botId = channelData.integration_data.botId;
        this.form.status = channelData.status;
      }
    }
  },
  async mounted() {
    this.fetchData();
    let response = await this.$axiosNoLoading.get(
      process.env.MIX_AUTH_URL + `/api/bots/${this.user.id}`
    );
    this.botList = response.data;
    EventBus.$on("toggleStatus", value => {
      this.fetchData();
    });
  }
};
</script>
<style lang="scss">
</style>
